// account.c

#ifndef UNICODE
#define UNICODE
#endif

#include <windows.h> 
#include <lm.h>

//-----------------------------------------------------------------
BOOL CreateUser(LPWSTR UserName, LPWSTR Password, LPWSTR ServerName)
{
    NET_API_STATUS NetStatus;
    USER_INFO_1 UserInfo;
    DWORD Error = 0;

    UserInfo.usri1_name        = UserName;
    UserInfo.usri1_password    = Password;
    UserInfo.usri1_priv        = USER_PRIV_USER;
    UserInfo.usri1_home_dir    = NULL;
    UserInfo.usri1_comment     = NULL;
    UserInfo.usri1_flags       = UF_SCRIPT;
    UserInfo.usri1_script_path = NULL;

    NetStatus = NetUserAdd(ServerName,1,(LPBYTE)&UserInfo,&Error);
    
    return ((NetStatus == NERR_Success) ? TRUE : FALSE);
}

//-----------------------------------------------------------------
BOOL DeleteUser(LPWSTR UserName, LPWSTR ServerName)
{
    NET_API_STATUS NetStatus;

    NetStatus = NetUserDel(ServerName, UserName);

    return ((NetStatus == NERR_Success) ? TRUE : FALSE);
}

//-----------------------------------------------------------------
BOOL CreateGroup(LPWSTR GroupName, LPWSTR ServerName)
{
    NET_API_STATUS NetStatus;
    LOCALGROUP_INFO_0 GroupInfo;
    DWORD Error = 0;

    GroupInfo.lgrpi0_name = GroupName;

    NetStatus = NetLocalGroupAdd(ServerName, 0, (LPBYTE)&GroupInfo,
                                 &Error);
    
    return ((NetStatus == NERR_Success) ? TRUE : FALSE);
}

//-----------------------------------------------------------------
BOOL DeleteGroup(LPWSTR GroupName, LPWSTR ServerName)
{
    NET_API_STATUS NetStatus;

    NetStatus = NetLocalGroupDel(ServerName, GroupName);

    return ((NetStatus == NERR_Success) ? TRUE : FALSE);
}

//-----------------------------------------------------------------
BOOL AddUserToGroup(LPWSTR UserName, LPWSTR GroupName, 
                    LPWSTR ServerName)
{
    NET_API_STATUS NetStatus;
    LOCALGROUP_MEMBERS_INFO_3 MembersInfo;

    MembersInfo.lgrmi3_domainandname = UserName;

    NetStatus = NetLocalGroupAddMembers(ServerName, GroupName, 3, 
                                        (LPBYTE)&MembersInfo, 1);
    
    return ((NetStatus == NERR_Success) ? TRUE : FALSE);
}

//-----------------------------------------------------------------
BOOL DeleteMemberFromGroup(LPWSTR MemberName, LPWSTR GroupName,
                           LPWSTR ServerName)
{
    NET_API_STATUS NetStatus;
    LOCALGROUP_MEMBERS_INFO_3 MembersInfo;

    MembersInfo.lgrmi3_domainandname = MemberName;

    NetStatus = NetLocalGroupDelMembers(ServerName, GroupName, 3, 
                                        (LPBYTE)&MembersInfo, 1);

    return ((NetStatus == NERR_Success) ? TRUE : FALSE);
}

